﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Enemy : MonoBehaviour {
    // Move left to right
    // if obstacle front him -> attack
    public AudioSource atkSound;

    protected Rigidbody2D rb;

    protected List<Structure> structColide = new List<Structure>();

    public int value = 10;
    public int timerAttck = 40;
    public int currentTimer = 20;
    public int damage = 3;
    public int health = 10;
    public float speed = 1;

    protected float random;
	// Use this for initialization
	void Start () {
        rb = GetComponent<Rigidbody2D>();
        random = Random.Range(2f, 7f);

    }
	
	// Update is called once per frame
	void Update ()
    {
        if (GameManager.gamePaused)
        {
            rb.velocity = Vector2.zero;
            return;
        }
        Move();
        SpecialAction();
        MeleeAction();

        if (rb.velocity != Vector2.zero)
        {
            float ang = Vector2.Angle(Vector2.right, rb.velocity);
            Vector3 cross = Vector3.Cross(Vector2.right, rb.velocity);

            if (cross.z > 0)
                ang = 360 - ang;

            transform.rotation = Quaternion.Euler(0, 0, -ang);
        }
    }

    public virtual void Destroy()
    {
        if (GameObject.Find("Game Manager") != null)
            GameObject.Find("Game Manager").GetComponent<GameManager>().AddScore(this);
        Destroy(gameObject);
    }

    protected virtual void Move()
    {
        if (transform.position.x > 2 && transform.position.y > 0 || transform.position.x > random)
        {
            rb.velocity = (new Vector3(7.67f, 0.36f, 0) - transform.position).normalized * speed;
        }
        else
        {
            rb.velocity = Vector2.right * speed;
        }
    }

    protected virtual void SpecialAction()
    {

    }

    protected virtual void MeleeAction()
    {

        if (structColide.Count != 0)
        {
            currentTimer--;
            if (currentTimer == 0)
            {
                Attack();
                currentTimer = timerAttck;
            }
        }
    }

    protected virtual void Attack()
    {
        if (atkSound != null) atkSound.Play();

        if (structColide[0] == null)
            structColide.RemoveAt(0);
        else
            structColide[0].Damage(damage);
    }

    void OnCollisionEnter2D(Collision2D col)
    {
        if(col.collider.gameObject.GetComponent<Structure>() != null)
            structColide.Add(col.collider.gameObject.GetComponent<Structure>());
    }

    void OnColisionExit2D(Collision2D col)
    {
        if (col.collider.gameObject.GetComponent<Structure>() != null)
            structColide.Remove(col.collider.gameObject.GetComponent<Structure>());
    }

    public virtual void Damage(int damages)
    {
        health -= damages;
        if (health <= 0)
            Destroy();
    }
}
