﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using System;
using System.IO;
using System.Runtime.Serialization.Formatters.Binary;


[Serializable]
public struct ScoreSave
{
    public string tag;
    public int points;

    public ScoreSave(string t, int p)
    {
        tag = t; points = p;
    }
}

[Serializable]
public class HighScores {
    public List<ScoreSave> scores = new List<ScoreSave>();

    public bool IsScoreBetter(int score, out int index)
    {
        for(int i = scores.Count-1; i >= 0; i--)
        {
            if(scores[i].points < score)
            {
                index = i;
                return true;
            }
        }
        if(scores.Count < 5)
        {
            index = scores.Count;
            return true;
        }
        index = -1;
        return false;
    }

    public void PlaceScore(string tag, int score, int index)
    {
        scores.Insert(index, new ScoreSave(tag, score));
        if(scores.Count > 5)
        {
            scores.RemoveAt(5);
        }
        HighScores.Save(this);
    }

    public static HighScores Load()
    {
        if(!File.Exists("saves"))
        {
            return new HighScores();
        }

        BinaryFormatter formatter = new BinaryFormatter();

        using (FileStream stream = new FileStream("saves", FileMode.Open))
        {
            try
            {
                return formatter.Deserialize(stream) as HighScores;
            }
            catch (Exception)
            {
                return new HighScores();
            }
        }
    }

    public static void Save(HighScores hs)
    {
        BinaryFormatter formatter = new BinaryFormatter();

        using (FileStream stream = new FileStream("saves", FileMode.Create))
        {
            try
            {
                formatter.Serialize(stream, hs);
            }
            catch (Exception)
            {

            }
        }

    }
}
