﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Bullet : MonoBehaviour {
    
    public GameObject hitAnimation;
    public float hitAnimeTime = 0.2f;

    public int mode = 0; // 0:player , 1:enemy

    public int strength = 5;
    public float speed = 1f;
    protected Rigidbody2D rb;
	// Use this for initialization
	void Start () {
        rb = GetComponent<Rigidbody2D>();
	}
	
	// Update is called once per frame
	void Update () {
        if (GameManager.gamePaused) return;

        if (transform.position.x < -9.5f)
            Destroy(gameObject);
        Move();
        SpecialEffect();
	}

    void OnCollisionEnter2D(Collision2D col)
    {
        HitTarget(col.collider);
    }

    protected virtual void SpecialEffect() { }
    protected virtual void Move()
    {
        rb.velocity = -transform.right * speed;
    }

    protected virtual void HitTarget(Collider2D col)
    {
        if (col.tag == "Enemy" && mode == 0)
        {
            if (col.GetComponent<Enemy>() != null)
                col.GetComponent<Enemy>().Damage(strength);
        }
        else if (col.gameObject.layer == 8 && mode == 1)
        {
            if(col.GetComponent<Structure>() != null)
                col.GetComponent<Structure>().Damage(strength);
        }
        GameObject.Find("Game Manager").GetComponent<GameManager>().StartCoroutine(HitAnim());
    }

    public IEnumerator HitAnim()
    {
        rb.velocity = Vector2.zero;
        Destroy(gameObject);
        GameObject exp = Instantiate(hitAnimation, transform.position, transform.rotation);
        yield return new WaitForSeconds(hitAnimeTime);
        Destroy(exp.gameObject);
    }
}
