﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Lazer : Bullet {

    int disapearTimer = 2;

    void Start()
    {
        rb = GetComponent<Rigidbody2D>();
        RaycastHit2D hitShield = Physics2D.Raycast(transform.position, -transform.right, 16); // , 1 << 9
        if (hitShield.collider != null)
        {
            float dist = Vector3.Distance(hitShield.point, transform.position);
            transform.localScale = new Vector3(dist / 8, 1, 1);
        }
        else
        {
            transform.localScale = new Vector3(2, 1, 1);
        }
    }

    protected override void Move()
    {
        disapearTimer--;
        transform.localScale = new Vector3(1, -1, 1);

        if (disapearTimer == 0)
            Destroy(gameObject);

    }
    protected override void SpecialEffect() {

        RaycastHit2D[] hits;
        RaycastHit2D hitShield = Physics2D.Raycast(transform.position, -transform.right, 16); // , 1 << 9
        if (hitShield.collider != null)
        {
            float dist = Vector3.Distance(hitShield.point, transform.position);
            transform.localScale = new Vector3(dist/8, -1, 1);
            hits = Physics2D.RaycastAll(transform.position, -transform.right, dist);
        }
        else
        {
            transform.localScale = new Vector3(2, -1, 1);
            hits = Physics2D.RaycastAll(transform.position, -transform.right, 16);
        }

        foreach (RaycastHit2D hit in hits)
        {
            if (hit.collider.tag == "Enemy" && mode == 0)
            {
                hit.collider.GetComponent<Enemy>().Damage(strength);
            }
        }
    }

    protected override void HitTarget(Collider2D col)
    {

    }
}
