﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Missile : Bullet {

    public AudioSource trajectSound;
    public AudioSource explodSound;

    void Start()
    {
        rb = GetComponent<Rigidbody2D>();
        trajectSound.Play();
    }
    protected override void HitTarget(Collider2D collider)
    {
        trajectSound.Stop();
        explodSound.Play();

        Vector2 point = new Vector2(transform.position.x, transform.position.y);
        Collider2D[] cols = Physics2D.OverlapCircleAll(point, 1);

        foreach (Collider2D col in cols)
        {
            if (col.gameObject.layer == 9)
            {
                Destroy(col.gameObject);
            }
            if (col.tag == "Enemy" && mode == 0)
            {
                col.GetComponent<Enemy>().Damage(strength);
            }
            else if (col.gameObject.layer == 8 && mode == 1)
            {
                col.GetComponent<Structure>().Damage(strength);
            }
        }
        GameObject.Find("Game Manager").GetComponent<GameManager>().StartCoroutine(HitAnim());
    }

}
