﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class NewHighScorePanel : MonoBehaviour {

    [SerializeField] Text score;
    [SerializeField] Text value;
    [SerializeField] GameObject cursor;
    [SerializeField] Text[] registerLetters;

    [SerializeField] GameObject[] letters;

    int currentEdit = 0;
    int cursorIndex = 0;

    int scoreValue;
    HighScores hs;
    int rank;

    bool joyMoved = false;

    void Start()
    {
        /*
        int scoreTemp = 100;
        /*
        HighScores _hs = HighScores.Load();
        int index;
        if(_hs.IsScoreBetter(scoreTemp, out index))
            Initialize(index, scoreTemp, _hs);
        */
    }

    public void Initialize(int r, int s, HighScores _hs)
    {
        rank = r;
        hs = _hs;
        scoreValue = s;
        score.text = scoreValue.ToString("00000000");

    }

	// Update is called once per frame
	void Update ()
    {

        if (Input.GetButtonDown("Action P1") || Input.GetButtonDown("Action P2"))
        {
            if(cursorIndex < 26)
            {
                currentEdit++;
                if (currentEdit == 3)
                {
                    currentEdit = 2;
                    cursorIndex = 27;
                }
            } else if(cursorIndex == 27)
            {
                string final = registerLetters[0].text + registerLetters[1].text + registerLetters[2].text;
                hs.PlaceScore(final, scoreValue, rank);
                GameObject.Find("Game Manager").GetComponent<GameManager>().StartCoroutine(GameObject.Find("Game Manager").GetComponent<GameManager>().BackToMenuAnim());
            }
            else if(currentEdit > 0)
            {
                registerLetters[currentEdit].text = "";
                currentEdit--;
            }
        }

        if (Input.GetKeyDown(KeyCode.RightArrow) || Input.GetKeyDown(KeyCode.D) || (!joyMoved && Input.GetAxis("Horizontal P1") > 0) || (!joyMoved && Input.GetAxis("Horizontal P2") > 0))
        {
            joyMoved = true;
            cursorIndex++;
            if (cursorIndex == 13) cursorIndex = 0;
            else if (cursorIndex == 26) cursorIndex = 13;
        }
        if (Input.GetKeyDown(KeyCode.LeftArrow) || Input.GetKeyDown(KeyCode.A) || (!joyMoved && Input.GetAxis("Horizontal P1") < 0) || (!joyMoved && Input.GetAxis("Horizontal P2") < 0))
        {
            joyMoved = true;
            cursorIndex--;
            if (cursorIndex == -1) cursorIndex = 12;
            else if (cursorIndex == 12) cursorIndex = 25;
        }

        if (Input.GetKeyDown(KeyCode.DownArrow) || Input.GetKeyDown(KeyCode.S) || (!joyMoved && Input.GetAxis("Vertical P1") < 0) || (!joyMoved && Input.GetAxis("Vertical P2") < 0))
        {
            joyMoved = true;
            if (cursorIndex < 13) cursorIndex += 13;
            else if (cursorIndex < 19) cursorIndex = 26;
            else if (cursorIndex < 26) cursorIndex = 27;
            else if (cursorIndex == 26) cursorIndex = 0;
            else if (cursorIndex == 27) cursorIndex = 12;
        }
        if (Input.GetKeyDown(KeyCode.UpArrow) || Input.GetKeyDown(KeyCode.W) || (!joyMoved && Input.GetAxis("Vertical P1") > 0) || (!joyMoved && Input.GetAxis("Vertical P2") > 0))
        {
            joyMoved = true;
            if (cursorIndex == 26) cursorIndex = 13;
            else if (cursorIndex == 27) cursorIndex = 25;
            else if (cursorIndex > 12) cursorIndex -= 13;
            else if (cursorIndex < 6) cursorIndex = 26;
            else if (cursorIndex < 13) cursorIndex = 27;
        }

        cursor.transform.position = letters[cursorIndex].transform.position;
        if (cursorIndex < 26)
        {
            registerLetters[currentEdit].text = letters[cursorIndex].GetComponent<Text>().text;
            cursor.transform.localScale = new Vector3(1, 1, 1);
        }
        else
            cursor.transform.localScale = new Vector3(2, 1, 1);


        if(Input.GetAxis("Vertical P1") == 0 && Input.GetAxis("Vertical P2") == 0 && Input.GetAxis("Horizontal P1") == 0 && Input.GetAxis("Horizontal P2") == 0)
        {
            joyMoved = false;
        }
    }
}
