﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class PlayerController : MonoBehaviour {

    public int playerID;

    public float speed = 1.5f;

    Rigidbody2D rb;

    public Box box;

    Turret canMountTurret;
    Turret mountedTurret;


	// Use this for initialization
	void Start () {
        rb = GetComponent<Rigidbody2D>();
	}
	
	// Update is called once per frame
	void Update ()
    {

        rb.velocity = Vector2.zero;

        if (mountedTurret != null)
        {
            mountedTurret.TurretControl();
        } else
        {
            CharacterControls();
        }
        if (GameManager.gamePaused) return;

        if (rb.velocity != Vector2.zero)
        {
            rb.velocity = rb.velocity.normalized * speed;

            float ang = Vector2.Angle(-Vector2.right, rb.velocity);
            Vector3 cross = Vector3.Cross(-Vector2.right, rb.velocity);

            if (cross.z > 0)
                ang = 360 - ang;

            transform.rotation = Quaternion.Euler(0, 0, -ang);
        }
    }

    void CharacterControls()
    {
        switch (playerID)
        {
            case 0:
                ControlsP1();
                break;
            case 1:
                ControlsP2();
                break;
        }
    }

    public void CanMount(Turret t)
    {
        canMountTurret = t;
    }
    public void Carry(Box b)
    {
        box = b;
    }
    void Mount()
    {
        if (canMountTurret == null || canMountTurret.player != null) return;

        rb.velocity = Vector2.zero;
        mountedTurret = canMountTurret;
        mountedTurret.player = this;
        transform.position = mountedTurret.transform.position;
        GetComponent<CircleCollider2D>().enabled = false;
    }

    public void Dismount()
    {
        transform.position = mountedTurret.transform.position + Vector3.right*0.5f;
        GetComponent<CircleCollider2D>().enabled = true;
        mountedTurret.player = null;
        mountedTurret = null;
    }

    void ControlsP1()
    {
        rb.velocity = new Vector2(Input.GetAxisRaw("Horizontal P1"), Input.GetAxisRaw("Vertical P1")).normalized;
        
        if (Input.GetButtonDown("Action P1"))
        {
            Mount();
        }
    }

    void ControlsP2()
    {
        rb.velocity = new Vector2(Input.GetAxisRaw("Horizontal P2"), Input.GetAxisRaw("Vertical P2")).normalized;

        if (Input.GetButtonDown("Action P2"))
        {
            Mount();
        }
    }
}
