﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Box : MonoBehaviour {

    public int resourceType = 0;
    public int quantity = 500;

    bool canTakeP1 = false;
    bool canTakeP2 = false;

    bool carried = false;

    PlayerController player1;
    PlayerController player2;

    Turret t;
    Barrier b;

    Rigidbody2D rb;

    // Use this for initialization
    void Start () {
        player1 = GameObject.Find("Player 1").GetComponent<PlayerController>();
        player2 = GameObject.Find("Player 2").GetComponent<PlayerController>();
        rb = GetComponent<Rigidbody2D>();

    }
	
	// Update is called once per frame
	void Update () {
        if (GameManager.gamePaused) return;

        if (carried)
        {
            if (this == player1.box)
                transform.position = player1.transform.position - player1.transform.right*0.3f;
            if (this == player2.box)
                transform.position = player2.transform.position - player2.transform.right*0.3f;
        }
        
        rb.velocity = Vector2.zero;
		if(canTakeP1 && Input.GetButtonDown("Action P1") && !carried && player1.box == null)
        {
            GetComponent<BoxCollider2D>().enabled = false;
            carried = true;
            transform.SetParent(player1.transform);
            transform.position = player1.transform.position - player1.transform.right * 0.3f;
            transform.rotation = player1.transform.rotation;
            player1.Carry(this);
        }
        else if (canTakeP2 && Input.GetButtonDown("Action P2") && !carried && player2.box == null)
        {
            GetComponent<BoxCollider2D>().enabled = false;
            carried = true;
            transform.SetParent(player2.transform);
            transform.position = player2.transform.position - player2.transform.right * 0.3f;
            transform.rotation = player2.transform.rotation;
            player2.Carry(this);
        }

        else if(carried && Input.GetButtonDown("Cancel P1") && this == player1.box)
        {
            GetComponent<BoxCollider2D>().enabled = true;
            carried = false;
            transform.SetParent(player1.transform.parent);
            player1.Carry(null);
        }
        else if (carried && Input.GetButtonDown("Cancel P2") && this == player2.box)
        {
            GetComponent<BoxCollider2D>().enabled = true;
            carried = false;
            transform.SetParent(player2.transform.parent);
            player2.Carry(null);
        }

        if(carried && t != null && this == player1.box && Input.GetButtonDown("Action P1"))
        {
            if (t.munitionType == resourceType)
            {
                t.Reload(quantity);
                Destroy(gameObject);
            } else if(resourceType == 3 && (float)t.health/t.maxHealth  < 0.75f)
            {
                t.Repair();
                Destroy(gameObject);
            }
        }

        if (carried && t != null && this == player2.box && Input.GetButtonDown("Action P2"))
        {
            if (t.munitionType == resourceType)
            {
                t.Reload(quantity);
                Destroy(gameObject);
            }
            else if (resourceType == 3 && (float)t.health / t.maxHealth < 0.75f)
            {
                t.Repair();
                Destroy(gameObject);
            }
        }


        if (carried && b != null && this == player1.box && Input.GetButtonDown("Action P1"))
        {
            if (resourceType == 3 && (float)b.health / b.maxHealth < 0.75f)
            {
                b.Repair();
                Destroy(gameObject);
            }
        }

        if (carried && b != null && this == player2.box && Input.GetButtonDown("Action P2"))
        {
            if (resourceType == 3 && (float)b.health / b.maxHealth < 0.75f)
            {
                b.Repair();
                Destroy(gameObject);
            }
        }
    }

    void OnTriggerEnter2D(Collider2D col)
    {
        if (col.tag == "Player")
        {
            if (col.GetComponent<PlayerController>().playerID == 0)
                canTakeP1 = true;
            else
                canTakeP2 = true;
        } if(col.tag == "Turret")
        {
            t = col.GetComponent<Turret>();
        }
        if (col.tag == "Barrier")
        {
            b = col.GetComponent<Barrier>();
        }
        if (col.tag == "Enemy" || col.gameObject.layer == 9)
        {
            Destroy(gameObject);
        }
    }

    void OnTriggerExit2D(Collider2D col)
    {
        if (col.tag == "Player")
        {
            if (col.GetComponent<PlayerController>().playerID == 0)
                canTakeP1 = false;
            else
                canTakeP2 = false;
        }
        if (col.tag == "Barrier")
        {
            b = null;
        }
        if (col.tag == "Turret")
        {
            t = null;
        }
    }
}
