﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class Factory : Structure {

    [SerializeField] AudioSource readySound;
    [SerializeField] GameObject[] mode;
    [SerializeField] Box[] boxes;
    [SerializeField] Text bulleText;

    public Vector3 instancePos;


    bool canUseP1 = false;
    bool canUseP2 = false;
    int currentMode = 3;

    string[] texts = { "<color=#d0ffa4>AUTOGUN</color>", "<color=#ff7214>CANNON</color>", "<color=#ffc909>LAZER</color>", "<color=#25ffd3>REPAIR</color>" };

    int[] reload = new int[4];
    int[] reloadTime = new int[4];

    int NextBoxType = 0;

    PlayerController player1;
    PlayerController player2;
    // Use this for initialization
    void Start ()
    {
        player1 = GameObject.Find("Player 1").GetComponent<PlayerController>();
        player2 = GameObject.Find("Player 2").GetComponent<PlayerController>();
        ChangeMode();
        reload[0] = 0;
        reload[1] = 0;
        reload[2] = 0;
        reload[3] = 0;
        reloadTime[0] = 600;
        reloadTime[1] = 700;
        reloadTime[2] = 800;
        reloadTime[3] = 100;

    }
	
	// Update is called once per frame
	void Update () {
        if (GameManager.gamePaused) return;

        if ((canUseP1 && Input.GetButtonDown("Action P1") && player1.box == null) || (canUseP2 && Input.GetButtonDown("Action P2") && player2.box == null))
        {
            ChangeMode();
        }
        if(reload[currentMode] < reloadTime[currentMode])
            reload[currentMode]++;
        else
        {
            CreateBox();
        }
    }

    public void ChangeMode()
    {
        mode[currentMode].SetActive(false);
        currentMode = (currentMode + 1) % 4;
        mode[currentMode].SetActive(true);
        bulleText.text = texts[currentMode];
    }

    void CreateBox()
    {
        readySound.Play();
        Box b = Instantiate(boxes[currentMode], transform.position + instancePos, Quaternion.identity);
        reload[currentMode] = 0;
       // currentMode = NextBoxType;
    }

    void OnTriggerEnter2D(Collider2D col)
    {
        if(col.tag == "Player")
        {
            if (col.GetComponent<PlayerController>().playerID == 0)
                canUseP1 = true;
            else
                canUseP2 = true;
        }
    }

    void OnTriggerExit2D(Collider2D col)
    {
        if (col.tag == "Player")
        {
            if (col.GetComponent<PlayerController>().playerID == 0)
                canUseP1 = false;
            else
                canUseP2 = false;
        }
    }
}
