﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Structure : MonoBehaviour {

    public int maxHealth = 10;
    public int health = 10;

    public Sprite[] destructionStates;

    public void Damage(int damage)
    {
        HitSpecialEffect();
        health -= damage;
        if (health <= 0)
            Destroy();
        else
        {
            float pourcentHealth = (float)health / maxHealth;
            if (pourcentHealth <= 0.25f)
                GetComponent<SpriteRenderer>().sprite = destructionStates[3];
            else if (pourcentHealth <= 0.5f)
                GetComponent<SpriteRenderer>().sprite = destructionStates[2];
            else if (pourcentHealth <= 0.75f)
                GetComponent<SpriteRenderer>().sprite = destructionStates[1];
            else
                GetComponent<SpriteRenderer>().sprite = destructionStates[0];
        }
    }

    public virtual void HitSpecialEffect()
    {

    }

    public void Repair()
    {
        GetComponent<SpriteRenderer>().sprite = destructionStates[0];
        health = maxHealth;
    }

    public virtual void Destroy()
    {
        Destroy(gameObject);
    }

    void OnTriggerEnter2D(Collider2D col)
    {
        if(col.tag == "Box")
        {

        }
    }
}
